#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int inf = 1e18;
const int mod = 1e9 + 7;

int t;

int LOG = 30;

vector<vector<int>> g;
vector<vector<int>> up;
vector<int> tin, tout;
vector<int> a;
vector<int> ans;
vector<int> pref;
int timer = 0;
vector<int> used;

bool anc(int a, int b) { // is a an ancestor of b
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void dfs(int v, int p, int h) {
    pref[v] = h + 1;
    tin[v] = timer++;
    used[v] = 1;
    used[p] = 1;

    for (int i = 0; i < LOG; i++) {
        up[v][0] = p;
    }

    for (int& u : g[v]) {
        if (u != p) {
            dfs(u, v, h + 1);
        }
    }

    tout[v] = timer++;
}

int lca(int a, int b) {
    if (anc(a, b)) {
        return a;
    }

    if (anc(b, a)) {
        return b;
    }

    for (int i = LOG - 1; i >= 0; i--) {
        if (!anc(up[a][i], b)) {
            a = up[a][i];
        }
    }

    return up[a][0];
}

int get(int a, int b) {
    return pref[a] + pref[b] - pref[lca(a, b)] - 1;
}

void solve() {
    int n, m, k;

    cin >> n >> m >> k;

    g.resize(n);
    up.resize(n, vector<int> (LOG));
    tin.resize(n);
    tout.resize(n);
    a.resize(n);
    ans.resize(n);
    pref.resize(n);
    used.resize(n);

    for (int i = 0; i < m; i++) {
        int u, v;

        cin >> u >> v;

        u--;
        v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    for (int i = 0; i < k; i++) {
        int p, h;

        cin >> p >> h;

        p--;

        a[p] = h;
        ans[p] = 1;
    }

    dfs(0, 0, 0);

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            continue;
        }

        if (ans[i]) {
            continue;
        }

        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                continue;
            }

            if (i == j) {
                continue;
            }

            if (!ans[j]) {
                continue;
            }

            if (abs(get(i, j)) <= a[j]) {
                ans[i] = 1;
                break;
            }
        }
    }

    int cnt = 0;

    for (int& i : ans) {
        cnt += i;
    }

    cout << cnt << endl;

    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << i + 1 << " ";
        }
    }
}

signed main() {
    // cout << fixed << setprecision(12);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}